/*---------------------------
Vvoj okennho systmu ve WinAPI
Bakalsk prce 2006, 
autor: Dolej Petr
login: xdolej06
Fakulta Informanch Technologi v Brn
---------------------------*/
/*
uivatelsk interakce na vznikl podnty
(vbr poloky menu,procedura okna apod.)
*/

#include "ivview_user_functions.h"
#include "ivview_functions.h"
#include "../Okenni rozhrani/SoWindow.h"
#include "../Okenni rozhrani/SoWinMenu.h"
#include "../prezentace.h"

extern SoOrthographicCamera *overlayCamera;
extern SbBool useWalkViewer;
extern SbBool showPerfMeter;
extern int numTris;
extern int numFramesRendered;
extern SbBool ivfix;
extern SbBool shapeHintBackface;

extern FileInfo files;
extern FileInfo files1;
extern FileInfo files2;
extern FileInfo files3;
extern FileInfo files4;

extern SoWinViewer *viewer;
extern SoWinViewer *viewer1;
extern SoWinViewer *viewer2;
extern SoWinViewer *viewer3;
extern SoWinViewer *viewer4;

extern SoWindow Uvodni_Okno;
extern SoWindow Okno1;
extern SoWindow Okno2;
extern SoWindow Okno3;

extern SoWinMENU Uvodni_Menu;
extern SoWinMENU Menu;
extern SoWinMENU Menu2;
extern SoWinMENU Menu3;
extern SoWinMENU Menu4;
extern SoWinMENU Menu5;
extern SoWinMENU Menu6;

SoWinMENU * ActMenu;
SoWindow  * ActOkno;


/*Procedura okna ve tet sti prezentace (kreslen)*/
void MyWndProc_Okno2(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{	
// Globln promnn pro buffering
static HDC g_hdcMem = NULL;
static HBITMAP g_hBitmapMem = NULL;

	switch(uMsg)/*zpracovn jednolivch zprv*/
	  {

	case WM_CREATE:/*vytvoen okna*/
		{
		RECT rect;
		HDC hdcScreen = GetDC(NULL);
		GetClientRect(hWnd, &rect);
		g_hdcMem = CreateCompatibleDC(hdcScreen);
		g_hBitmapMem = CreateCompatibleBitmap(hdcScreen, rect.right, rect.bottom);
		SelectObject(g_hdcMem, g_hBitmapMem);
		FillRect(g_hdcMem, &rect, GetSysColorBrush(COLOR_WINDOW));
		ReleaseDC(NULL, hdcScreen);
		break;}

	case WM_PAINT: /*pekreslen okna*/
        {
		HDC hDC;
		RECT rect;
		PAINTSTRUCT ps;

		GetClientRect(hWnd, &rect);
		hDC = BeginPaint(hWnd, &ps);
		BitBlt(hDC,0,0,rect.right, rect.bottom,g_hdcMem, 0,0,SRCCOPY);
		EndPaint(hWnd, &ps);
		break;}
	
	case WM_MOUSEMOVE: /*pohyb myi*/
        {  	
		if ( wParam & MK_LBUTTON )
			LineTo(g_hdcMem, LOWORD(lParam), HIWORD(lParam));
		else
			MoveToEx(g_hdcMem, LOWORD(lParam), HIWORD(lParam), NULL);

		RedrawWindow(hWnd, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);
		break;}
	
	case WM_RBUTTONDOWN:/*stisk pravho tlatka*/
		{
		RECT rect;
		GetClientRect(hWnd, &rect);
		FillRect(g_hdcMem, &rect, GetSysColorBrush(COLOR_WINDOW));
		RedrawWindow(hWnd, NULL, NULL, RDW_UPDATENOW | RDW_INVALIDATE);
		break;}

	case WM_ERASEBKGND:
		{
		return;
		break;}
	
	case WM_CLOSE:/*zaven okna*/
		::MessageBox(
			 hWnd,
			"Vvoj okennho systmu ve WinAPI \n \
Bakalsk prce 2006,  \n \
autor: Dolej Petr \n \
login: xdolej06 \n \
Fakulta Informanch Technologi v Brn",
"Prezentace vybranch st okennho rozhran ve WinAPI",
			MB_OK);
	Menu5.Close();
     break;
	}
}
/*Procedura okna ve tet sti prezentace - jednoduch okno*/
void MyWndProc_Okno3(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{		
	switch(uMsg)
	{	
	case WM_LBUTTONDOWN:/*stisk levho tlatka*/
		::MessageBox(hWnd,"Bylo stisknuto lev tlatko myi ","Odchyt udlosti WM_LBUTTONDOWN",MB_OK);
	break;
		
	case WM_CLOSE:
		Menu6.Close();
	break;
	}
}

/*Procedura 4. MDI okna (2. st prezentace)*/
void MyChildProces (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch(uMsg)
	{	      
	 case WM_CLOSE:/*reakce na uzaven okna*/
     ::MessageBox(hWnd,"WM_CLOSE","Zpracovn pijat zprvy child okna 4",MB_OK);
     break;
	}
}

///////////////////////////////////////////////////////////////////
//
// Process the topbar menu events.
//
/*zpracovvn zprv od menu*/
void Obsluha_Uvodni_Menu(int id)
{	static SoWinMENU * MyMenu= &Uvodni_Menu;
	static SoWindow * MyWindow = &Uvodni_Okno;
	static SoWinViewer *Myviewer = viewer;
	static FileInfo Myfiles = files;
	ActOkno = MyWindow;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu;
	viewer = Myviewer;
	files = Myfiles;
	
	if (id==40100)/*poloka menu -> Dal prezentace*/
	{	
		MyMenu->Close();
		ActOkno->Close();
		Prezentace_MDI();
	}
	else
	{	/*pedn procedue pro ovldn menu*/
		Ovladani_menu_IVIEW(id);
	}
}

/*zpracovvn zprv od menu*/
void processTopbarEvent2(int id)
{	static SoWinMENU * MyMenu2 = &Menu2;
	static SoWindow * MyWindow2 = &Okno1;
	static SoWinViewer *Myviewer2 = viewer2;
	static FileInfo Myfiles2 = files2;
	ActOkno = MyWindow2;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu2;
	viewer=Myviewer2;
	files = Myfiles2;
	Ovladani_menu_IVIEW(id);
}

/*zpracovvn zprv od menu*/
void processTopbarEvent3(int id)
{	static SoWinMENU * MyMenu3 = &Menu3;
	static SoWindow * MyWindow3 = &Okno1;
	static SoWinViewer *Myviewer3 = viewer3;
	static FileInfo Myfiles3 = files3;
	ActOkno = MyWindow3;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu3;
	viewer=Myviewer3;
	files = Myfiles3;
	Ovladani_menu_IVIEW(id);
}

/*zpracovvn zprv od menu*/
void processTopbarEvent4(int id)
{	static SoWinMENU * MyMenu4 = &Menu4;
	static SoWindow * MyWindow4 = &Okno1;
	static SoWinViewer *Myviewer4 = viewer4;
	static FileInfo Myfiles4 = files4;
	ActOkno = MyWindow4;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu4;
	viewer=Myviewer4;
	files = Myfiles4;
	Ovladani_menu_IVIEW(id);
}

/*zpracovvn zprv od menu*/
void Prezentace_3_okno1(int id)
{	static SoWinMENU * MyMenu5 = &Menu5;
	static SoWindow * MyWindow5 = &Okno2;
	ActOkno = MyWindow5;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu5;
	
	if (id==40188)	/*poloka sma obrazovku*/
	{	
	   ::SendMessage(ActOkno->GetHWND(),WM_RBUTTONDOWN,0,0);	//simulace stisku praveho tlacitka mysi
	}
	else
	Ovladani_menu_IVIEW(id);
}

/*zpracovvn zprv od menu*/
void Prezentace_3_okno2(int id)
{	static SoWinMENU * MyMenu6 = &Menu6;
	static SoWindow * MyWindow6 = &Okno3;
	ActOkno = MyWindow6;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu6;
	Ovladani_menu_IVIEW(id);
}

/*zpracovvn zprv od menu*/
void processTopbarEvent1(int id)
{	static SoWinMENU * MyMenu1 = &Menu;
	static SoWindow * MyWindow1 = &Okno1;
	static SoWinViewer *Myviewer1 = viewer1;
	static FileInfo Myfiles1 = files1;
	ActOkno = MyWindow1;/*nastaven promnch na aktuln okno (ivviewer)*/
	ActMenu = MyMenu1;
	viewer=Myviewer1;
	files = Myfiles1;
	Ovladani_menu_IVIEW(id);
}

/*funkce pro ovldn zprv menu 
(je zde vyuito stejnch ID poloek menu, take tato funkce je volna na vechna menu)*/
void Ovladani_menu_IVIEW(int id)
{
	switch (id)       {

	//
    // File
    //

    case 40008:/*poloka About*/
         showAboutDialog();
        break;

    case 40012:/*otevt*/
        getNewScene();
        break;

    case 40013:/*konec*/
        exit (0);
        break;

    //
    // Edit
    //

    case 40016:/*High qi transparency*/
		#ifdef _WIN32
		ActMenu->ToggleMenuItemChecked(id);
		#endif
        // Toggle the transparency mode
        if (viewer->getTransparencyType() == SoGLRenderAction::SCREEN_DOOR)
            viewer->setTransparencyType(SoGLRenderAction::DELAYED_BLEND);
        else
            viewer->setTransparencyType(SoGLRenderAction::SCREEN_DOOR);
        break;

	case 40017:{/*vbr barvy*/
	#ifdef _WIN32
		DWORD col,temp=0;
		float transparency=1;
		SbColor color;
		if (Open_ColorDialog(&col, ActOkno->GetHWND())==FALSE){
			fprintf(stderr, "Error: color dialog\n");}
		else {
			temp=(LOWORD(col)&0x00FF)*256;
			temp+=(LOWORD(col)&0xFF00)/256;
			temp=temp*256;
			temp+=(HIWORD(col)&0x00FF);
			temp=temp*256;
			color.setPackedValue(temp,transparency);
			viewer->setBackgroundColor(color);
		}
	#else
        editBackgroundColor();
    #endif
		
		break;}

    //
    // Optimize
    //
    case 40024:/*Optimize fo speed (ivfix)*/
		#ifdef _WIN32
		ActMenu->ToggleMenuItemChecked(id);
		#endif
        ivfix = !ivfix;
        optimizationChanged(files, TRUE);
        break;

    case 40025:/*Cull backfaces*/
		#ifdef _WIN32
		ActMenu->ToggleMenuItemChecked(id);
		#endif
        shapeHintBackface = !shapeHintBackface;
        optimizationChanged(files, TRUE);
        break;

	case 40200:/*Statick okno*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			RECT * lpRect=(RECT *)malloc(sizeof(RECT));
			GetWindowRect(ActOkno->GetHWND(),lpRect);
			ActOkno->SetStaticWindowPos(lpRect->left,lpRect->top);
			EnableMenuItem(ActMenu->GetHMENU(), 40201, MF_BYCOMMAND| MF_GRAYED);
		}
		else
		{ 
			ActOkno->SetStaticWindowPos(-1,-1);
		    EnableMenuItem(ActMenu->GetHMENU(), 40201, MF_BYCOMMAND| MF_ENABLED);
		}
		break;

	case 40201:/*Omezit pohyb okna*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			RECT * lpRect=(RECT *)malloc(sizeof(RECT));
			GetWindowRect(ActOkno->GetHWND(),lpRect);
			ActOkno->SetMinMaxWindowPos(lpRect->left+200,lpRect->top+200,lpRect->left,lpRect->top);
			EnableMenuItem(ActMenu->GetHMENU(), 40200, MF_BYCOMMAND| MF_GRAYED);
		}
		else 
		{
			ActOkno->SetMinMaxWindowPos(-1,-1,-1,-1);
		    EnableMenuItem(ActMenu->GetHMENU(), 40200, MF_BYCOMMAND| MF_ENABLED);
		}
		break;

	case 40202:/*Vdy navrchu*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			ActOkno->SetWindowPos(HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
		}
		else 
			ActOkno->SetWindowPos(HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
		break;

	case 40203:/*Nastav min,max velikost okna (600,700,250,300)*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			ActOkno->SetMinMaxInfo(-1,-1,-1,-1,600,700,250,300);
		}
		else 
			ActOkno->SetMinMaxInfo(-1,-1,-1,-1,-1,-1,-1,-1);
		break;

	case 40220:/*Statick okno*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			RECT * lpRectMDI=(RECT *)malloc(sizeof(RECT));
			RECT * lpRect=(RECT *)malloc(sizeof(RECT));
			GetWindowRect(ActOkno->GetMDIActiveHWND(),lpRectMDI);
			GetWindowRect(GetParent(ActOkno->GetMDIActiveHWND()),lpRect);
			ActOkno->SetMDIStaticWindowPos(ActOkno->GetMDIActiveHWND(),lpRectMDI->left-lpRect->left,lpRectMDI->top-lpRect->top);
			EnableMenuItem(ActMenu->GetHMENU(), 40221, MF_BYCOMMAND| MF_GRAYED);
		}
		else
		{ 
			ActOkno->SetMDIStaticWindowPos(ActOkno->GetMDIActiveHWND(),-1,-1);
		    EnableMenuItem(ActMenu->GetHMENU(), 40221, MF_BYCOMMAND| MF_ENABLED);
		}
		break;

	case 40221:/*Omezit pohyb okna*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			RECT * lpRectMDI=(RECT *)malloc(sizeof(RECT));
			RECT * lpRect=(RECT *)malloc(sizeof(RECT));
			GetWindowRect(ActOkno->GetMDIActiveHWND(),lpRectMDI);
			GetWindowRect(GetParent(ActOkno->GetMDIActiveHWND()),lpRect);
			ActOkno->SetMDIMinMaxWindowPos(ActOkno->GetMDIActiveHWND(),lpRectMDI->left-lpRect->left+200,lpRectMDI->top-lpRect->top+200,lpRectMDI->left-lpRect->left,lpRectMDI->top-lpRect->top);
			EnableMenuItem(ActMenu->GetHMENU(), 40220, MF_BYCOMMAND| MF_GRAYED);
		}
		else 
		{
			ActOkno->SetMDIMinMaxWindowPos(ActOkno->GetMDIActiveHWND(),-1,-1,-1,-1);
		    EnableMenuItem(ActMenu->GetHMENU(), 40220, MF_BYCOMMAND| MF_ENABLED);
		}
		break;

	case 40223:/*Nastav min,max velikost okna*/
		if (ActMenu->ToggleMenuItemChecked(id))
		{
			ActOkno->SetMDIMinMaxInfo(ActOkno->GetMDIActiveHWND(),-1,-1,-1,-1,600,700,250,300);
		}
		else 
			ActOkno->SetMDIMinMaxInfo(ActOkno->GetMDIActiveHWND(),-1,-1,-1,-1,-1,-1,-1,-1);
		break;

	case 40300:/*Dal prezentace z 2. prezentanho okna*/
		ActOkno->Close();
		Vlastni_WndProc();
		break;
		
	case 40301:{				//About Box 1. prezentanho okna
		::MessageBox(
			 NULL,
			"Toto samostatn okno pro Ivview \n \
je pln funkn se vemi monostmi Ivview. \n \
Pro ukzku je doplnno menu o monosti prce \n \
s oknem (omezovn jeho pohybu). Toto menu je \n \
nateno z textovho souboru \"uvodni_menu.txt\",\n \
co umouje nepouvat resource soubory, \n \
kter nemus bt v nkterch pekladach podporovny...\n \
Pro zbnou prezentaci dalch monost slou poloka menu: \n \
[Prezentace rozhran]->[Dal]",
"Prezentace vybranch st okennho rozhran ve WinAPI",
		    MB_OK);
		break;}
	
	case 40302:{				//About Box 2. prezentanho okna
		::MessageBox(
			 NULL,
			"Ukzka vyuit MDI rozhran pro Ivview, \n \
co umouje vyuit pln funkn Ivview se vemi \n \
monostmi ve vce instancch. Tato jednotliv okna jsou \n \
na sob vzjemn nezvisl a tm umouj jejich pouit \n \
odlinm zpsobem. Jejich pohyb je omezen v rmci jejich \n \
nadazenho hlavnho okna. Pro jednodu prci s nimi, \n \
je zde pidna (voliteln monost pi vytven okna) poloka v menu \n \
[Windows], kter usnaduje uspodvn oken.\n \
Kad okno m svoje vlastn menu,\n \
naten z textovho souboru. \n \
Okna mohou mt vlastn obsluhu zprv (pklad okna 4 pi jeho uzaven).\n \
Samozejm nechyb jako v pedchoz ukzce monost omezen pohybu okna.\n \
Pro zbnou prezentaci dalch monost slou poloka menu: \n \
[Prezentace rozhran]->[Dal]",
"Prezentace vybranch st okennho rozhran ve WinAPI",
			MB_OK);
		break;}	
	
	case 40303:{				//About Box 3. prezentanho okna
		::MessageBox(
			 NULL,
			"Toto je ukzka dvou na \n \
sob naprosto nezvislch oken, se zpracovnm \n \
jejich smyky zprv a monost vyuit rznch styl oken.\n \
(vech definovanch v MSDN).\n \
Jedno okno reaguje na stisk levho tlatka myi, \n \
v druhm je naznaeno, e nen problm okno vyut k \n \
naprosto libovolnmu pouit. \n \
(protoe uivatel m k dispozici monost vlastn obsluhy smyky zprv).",
"Prezentace vybranch st okennho rozhran ve WinAPI",
		    MB_OK);
		break;}

	}
}